#include	<windows.h>
#include	<stdio.h>
#include	<string.h>

#include	"common.h"
#include	"resource.h"
#include	"xmil.h"
#include	"ddraws.h"
#include	"ddrawbmp.h"
#include	"dinputs.h"
#include	"x1.h"
#include	"x1_crtc.h"
#include	"dialog.h"
#include	"ini.h"
#include	"menu.h"
#include	"timer.h"
#include	"dsounds.h"
#include	"opm.h"
#include	"dosio.h"
#include	"trace.h"
#include	"input.h"
#include	"draw.h"
#include	"x1_fdc.h"
#include	"fdd_ini.h"
#include	"winloc.h"
#include	"mouses.h"
#include	"newdisk.h"
#include	"dclock.h"
#if T_TUNE
#include	"x1_cmt.h"
#include	"drawinfo.h"
#endif

#if T_TUNE
		char		szProgName[] = "X millennium T-tune";
#else
		char		szProgName[] = "X millennium";
#endif
const	char		szClassName[] = "Xmill-MainWindow";
		HWND		hWndMain;
		HWND		hInst;
static	BYTE		xmilforeground = 0;
		BYTE		xmilopening = 1;
		int			winx, winy;
		XMIL_CFG	xmilcfg = {0, 0, 1, 0, 1, 2, 0, 1, 22050, 1000, 0, 0,
								0, 0, 0, 80, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0,
								1, 0, 0,
								0, 0, 0xffffff, 0xffbf6a};

BYTE changescreen(BYTE mode) {

	if ((mode) && !ddraws_setscreenmode(mode)) {
		return(SUCCESS);
	}
	DSound_Stop();
	mouse_running(MOUSE_STOP);
	ddraws_TermDirectDraw();
	ddraws_windowstats();
	if (ddraws_InitDirectDraw()) {
		disable_windowmenu();
		ddraws_setscreenmode(SCMD_XORWINDOWED);
		ddraws_windowstats();
		if (ddraws_InitDirectDraw()) {
			return(FAILURE);
		}
	}
	ddraws_redraw();
	mouse_running(MOUSE_CONT);
	DSound_Play();
	return(SUCCESS);
}


// --------------------------------------------------------------------------

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {

	PAINTSTRUCT	ps;
	RECT		rc;
	HDC			hdc;

	switch (msg) {
		case WM_CREATE:
			DragAcceptFiles(hWnd, TRUE);
			break;

		case WM_SYSCOMMAND:
			switch(wParam) {
				case IDM_SCREENCENTER:
					if (SCREENMODE & SCMD_WINDOWED) {
						ddraws_wincenter();
					}
					break;
				case IDM_SNAPENABLE:
					INIT_RENEWAL xmenu_setwinsnap(xmilcfg.WINSNAP ^ 1);
					break;
				case IDM_BACKGROUND:
					INIT_RENEWAL xmenu_setbackground(xmilcfg.background ^ 1);
					break;
				case IDM_BGSOUND:
					INIT_RENEWAL xmenu_setbgsound(xmilcfg.background ^ 2);
					break;
#ifdef TRACE
				case IDM_TRACEONOFF:
					trace_sw ^= 1;
					CheckMenuItem(GetSystemMenu(hWndMain, FALSE),
									IDM_TRACEONOFF, 
									(trace_sw?MF_CHECKED:MF_UNCHECKED));
					break;
#endif
				default:
					return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDM_IPLRESET:
					if (reset_x1(xmilcfg.ROM_TYPE,
								xmilcfg.SOUND_SW, xmilcfg.DIP_SW)) {
						PostQuitMessage(0);
					}
					break;
				case IDM_NMIRESET:
					Z80_NonMaskedInterrupt();
					break;
				case IDM_CONFIG:
					DSound_Stop();
					ddraws_topwinui();
					DialogBox(hInst, MAKEINTRESOURCE(IDD_CONFIG),
									hWnd, (DLGPROC)CfgDialogProc);
					ddraws_clearwinui();
					DSound_Play();
					break;
				case IDM_NEWDISK:
					DSound_Stop();
					ddraws_topwinui();
					newdisk(hWnd);
					ddraws_clearwinui();
					DSound_Play();
					break;
				case IDM_EXIT:
					SendMessage(hWnd, WM_CLOSE, 0, 0L);
					break;

				case IDM_FDD0OPEN:
					changefdd(0);
					break;
				case IDM_FDD0EJECT:
					x1_set_fd(0, 0, NULL);
					makecaption(1, NULL);
					break;

				case IDM_FDD1OPEN:
					changefdd(1);
					break;
				case IDM_FDD1EJECT:
					x1_set_fd(1, 0, NULL);
					makecaption(1, NULL);
					break;
#if T_TUNE
				case IDM_CMTOPEN:
					changetape();
					break;
				case IDM_CMTEJECT:
					cmt_eject();
					break;
				case IDM_CMTSTOP:
					cmt_stop();
					break;
				case IDM_CMTFF:
					cmt_ff();
					break;
				case IDM_CMTREW:
					cmt_rew();
					break;
				case IDM_CMTAFF:
					cmt_apss_ff();
					break;
				case IDM_CMTAREW:
					cmt_apss_rew();
					break;
				case IDM_CMTPROTECT:
					cmt_set_protect(tape.header.protect ? 0 : 1);
					break;
#endif //T_TUNE

				case IDM_TURBOZ:
					INIT_RENEWAL xmenu_setiplrom(3);
					break;
				case IDM_TURBO:
					INIT_RENEWAL xmenu_setiplrom(2);
					break;
				case IDM_X1ROM:
					INIT_RENEWAL xmenu_setiplrom(1);
					break;

				case IDM_BOOT2D:
					INIT_RENEWAL xmenu_setbootmedia(0);
					break;
				case IDM_BOOT2HD:
					INIT_RENEWAL xmenu_setbootmedia(DIP_BOOTMEDIA);
					break;

				case IDM_HIGHRES:
					INIT_RENEWAL xmenu_setresolute(0);
					break;
				case IDM_LOWRES:
					INIT_RENEWAL xmenu_setresolute(DIP_RESOLUTE);
					break;

				case IDM_WINDOW:
					if (changescreen(SCMD_SETWINDOWED)) {
						PostQuitMessage(0);
					}
					break;
				case IDM_FULLSCREEN:
					if (changescreen(SCMD_SETFULLSCREEN)) {
						PostQuitMessage(0);
					}
					break;
				case IDM_WIDTH80:
					crtc.TXT_XL = 80;
					crtc.GRP_XL = 640;
					vrambank_patch();
					scrnallflash = 1;
					break;
				case IDM_WIDTH40:
					crtc.TXT_XL = 40;
					crtc.GRP_XL = 320;
					vrambank_patch();
					scrnallflash = 1;
					break;
				case IDM_DISPSYNC:
					xmenu_setdispmode(xmilcfg.DISPSYNC ^ 1);
					break;
				case IDM_NOWAIT:
					INIT_RENEWAL xmenu_setwaitflg(xmilcfg.NOWAIT ^ 1);
					break;
				case IDM_RASTER:
					INIT_RENEWAL xmenu_setflame(0);
					break;
				case IDM_60FPS:
					INIT_RENEWAL xmenu_setflame(1);
					break;
				case IDM_30FPS:
					INIT_RENEWAL xmenu_setflame(2);
					break;
				case IDM_20FPS:
					INIT_RENEWAL xmenu_setflame(3);
					break;
				case IDM_15FPS:
					INIT_RENEWAL xmenu_setflame(4);
					break;

				case IDM_KEY:
					xmenu_setkey(0);
					break;
				case IDM_JOY1:
					xmenu_setkey(1);
					break;
				case IDM_JOY2:
					xmenu_setkey(2);
					break;
				case IDM_FMBOARD:
					INIT_RENEWAL xmenu_setsound(xmilcfg.SOUND_SW ^ 1);
					break;
				case IDM_JOYSTICK:
					INIT_RENEWAL xmenu_setjoystick(xmilcfg.JOYSTICK ^ 1);
					break;
				case IDM_MOUSE:
					INIT_RENEWAL xmenu_setmouse(xmilcfg.MOUSE_SW ^ 1);
					break;
#if T_TUNE
				case IDM_4MHZ:
					xmilcfg.CPU8MHz = 4;
					INIT_RENEWAL xmenu_setcpuspeed(xmilcfg.CPU8MHz);
					break;
				case IDM_5MHZ:
					xmilcfg.CPU8MHz = 5;
					INIT_RENEWAL xmenu_setcpuspeed(xmilcfg.CPU8MHz);
					break;
				case IDM_6MHZ:
					xmilcfg.CPU8MHz = 6;
					INIT_RENEWAL xmenu_setcpuspeed(xmilcfg.CPU8MHz);
					break;
				case IDM_8MHZ:
					xmilcfg.CPU8MHz = 8;
					INIT_RENEWAL xmenu_setcpuspeed(xmilcfg.CPU8MHz);
					break;
				case IDM_10MHZ:
					xmilcfg.CPU8MHz = 10;
					INIT_RENEWAL xmenu_setcpuspeed(xmilcfg.CPU8MHz);
					break;
				case IDM_12MHZ:
					xmilcfg.CPU8MHz = 12;
					INIT_RENEWAL xmenu_setcpuspeed(xmilcfg.CPU8MHz);
					break;
#else //T_TUNE
				case IDM_8MHZ:
					INIT_RENEWAL xmenu_setcpuspeed(xmilcfg.CPU8MHz ^ 1);
					break;
#endif //T_TUNE
				case IDM_SEEKSND:
					INIT_RENEWAL xmenu_setmotorflg(xmilcfg.MOTOR ^ 1);
					break;

				case IDM_BMPSAVE:
					bmpsave();
					break;
				case IDM_OPMLOG:
					INX1F_logging();
					break;
				case IDM_DISPCLOCK:
					INIT_RENEWAL xmenu_setdispclk(xmilcfg.DISPCLK ^ 1);
					break;
				case IDM_DISPFLAME:
					INIT_RENEWAL xmenu_setdispclk(xmilcfg.DISPCLK ^ 2);
					break;
				case IDM_SKIPLINE:
					INIT_RENEWAL xmenu_setskipline(xmilcfg.SKIP_LINE ^ 1);
					break;
				case IDM_JOYX:
					INIT_RENEWAL xmenu_setbtnmode(xmilcfg.BTN_MODE ^ 1);
					break;
				case IDM_RAPID:
					INIT_RENEWAL xmenu_setbtnrapid(xmilcfg.BTN_RAPID ^ 1);
					break;
				case IDM_HALFBMP:
					bmpsavehalf();
					break;
				case IDM_Z80SAVE:
					debug_status();
					break;
				case IDM_ABOUT:
					DSound_Stop();
					ddraws_topwinui();
					DialogBox(NULL, MAKEINTRESOURCE(IDD_ABOUT),
									hWnd, (DLGPROC)AboutDialogProc);
					ddraws_clearwinui();
					DSound_Play();
					break;
			}
			break;

		case WM_ACTIVATE:
			joy_foregroundprc(wParam);
			if (LOWORD(wParam) != WA_INACTIVE) {
				xmilforeground = 0;
				ddraws_drawall();
				mouse_running(MOUSE_CONT_M);
				DSound_MasterON();
			}
			else {
				xmilforeground = 1;
				mouse_running(MOUSE_STOP_M);
				if (xmilcfg.background) {
					DSound_MasterOFF();
				}
			}
			break;

		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			if (xmilopening) {

			    HDC			hmdc;
			    HBITMAP		hbmp;
			    BITMAP		bmp;
			    HINSTANCE	hinst;

			    hinst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
    			hbmp = LoadBitmap(hinst, "XMILBMP");
			    GetObject(hbmp, sizeof(BITMAP), &bmp);
			    hmdc = CreateCompatibleDC(hdc);
			    SelectObject(hmdc, hbmp);
			    BitBlt(hdc, (SCREEN_WIDTH - 201) / 2,
			    			(SCREEN_HEIGHT - 31) / 2,
							bmp.bmWidth, bmp.bmHeight, hmdc, 0, 0, SRCCOPY);
			    DeleteDC(hmdc);
	    		DeleteObject(hbmp);

    			hbmp = LoadBitmap(hinst, "ZILOG");
			    GetObject(hbmp, sizeof(BITMAP), &bmp);
			    hmdc = CreateCompatibleDC(hdc);
			    SelectObject(hmdc, hbmp);
			    BitBlt(hdc, (SCREEN_WIDTH - (101 + 8 + 41 + 8 + 68 + 1)),
			    			(SCREEN_HEIGHT - 38),
							bmp.bmWidth, bmp.bmHeight, hmdc, 0, 0, SRCCOPY);
			    DeleteDC(hmdc);
	    		DeleteObject(hbmp);

    			hbmp = LoadBitmap(hinst, "TURBOZ");
			    GetObject(hbmp, sizeof(BITMAP), &bmp);
			    hmdc = CreateCompatibleDC(hdc);
			    SelectObject(hmdc, hbmp);
			    BitBlt(hdc, (SCREEN_WIDTH - (101 + 8 + 68 + 1)),
			    			(SCREEN_HEIGHT - 18),
							bmp.bmWidth, bmp.bmHeight, hmdc, 0, 0, SRCCOPY);
			    DeleteDC(hmdc);
	    		DeleteObject(hbmp);

    			hbmp = LoadBitmap(hinst, "OPMSOUND");
			    GetObject(hbmp, sizeof(BITMAP), &bmp);
			    hmdc = CreateCompatibleDC(hdc);
			    SelectObject(hmdc, hbmp);
			    BitBlt(hdc, (SCREEN_WIDTH - (68+1)),
			    			(SCREEN_HEIGHT - (25+1)),
							bmp.bmWidth, bmp.bmHeight, hmdc, 0, 0, SRCCOPY);

			    DeleteDC(hmdc);
	    		DeleteObject(hbmp);
			}
			else {
//				ddraws_redraw();
				ddraws_drawall();
			}
			EndPaint(hWnd, &ps);
			break;

		case WM_QUERYNEWPALETTE:
			ddraws_palette();
			break;
		case WM_MOVE:
			if (SCREENMODE & SCMD_WINDOWED) {
				GetWindowRect(hWnd, &rc);
				INIT_RENEWAL
					winx = rc.left;
					winy = rc.top;
			}
			break;

		case WM_ENTERMENULOOP:
			DSound_Stop();
			ddraws_topwinui();
			if (!(SCREENMODE & SCMD_WINDOWED)) {
				DrawMenuBar(hWnd);
			}
			break;
		case WM_EXITMENULOOP:
			ddraws_clearwinui();
			DSound_Play();
			break;
		case WM_ENTERSIZEMOVE:
			DSound_Stop();
			mouse_running(MOUSE_STOP);
			win_movingstart();
			break;
		case WM_EXITSIZEMOVE:
			mouse_running(MOUSE_CONT);
			DSound_Play();
			break;
		case WM_MOVING:
			if (xmilcfg.WINSNAP) {
				win_movingproc((RECT *)lParam);
			}
			break;

		case WM_KEYDOWN:
			if (wParam == VK_F12) {
				mouse_running(MOUSE_XOR);
			}
			else {
				winkeydown106(wParam, lParam);
			}
			break;
		case WM_KEYUP:
			winkeyup106(wParam, lParam);
			break;

		case WM_SYSKEYDOWN:
			if (wParam == VK_F10) {
				return(DefWindowProc(hWnd, WM_SYSKEYDOWN, wParam, lParam));
			}
			winkeydown106(wParam, lParam);
			break;

		case WM_SYSKEYUP:
			if (wParam == VK_F10) {
				return(DefWindowProc(hWnd, WM_SYSKEYUP, wParam, lParam));
			}
			else {
				winkeyup106(wParam, lParam);
			}
			break;

		case WM_LBUTTONDOWN:
			if (!mouse_btn(MOUSE_LEFTDOWN)) {
#if T_TUNE
				drawinfo_click((WORD)(lParam&0xffff),(WORD)(lParam>>16),0,wParam&MK_SHIFT);
#endif
				return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;
		case WM_LBUTTONUP:
			if (!mouse_btn(MOUSE_LEFTUP)) {
				if (SCREENMODE & SCMD_FULLSCRN) {
					POINT	p;
					if ((GetCursorPos(&p)) && (p.y >= 466)) {
						INIT_RENEWAL xmilcfg.clockx++;
						dclock_reset();
					}
				}
				return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;
		case WM_RBUTTONDOWN:
			if (!mouse_btn(MOUSE_RIGHTDOWN)) {
#if T_TUNE
				drawinfo_click((WORD)(lParam&0xffff),(WORD)(lParam>>16),1,wParam&MK_SHIFT);
#endif
				return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;
		case WM_RBUTTONUP:
			if (!mouse_btn(MOUSE_RIGHTUP)) {
				if (SCREENMODE & SCMD_FULLSCRN) {
					POINT	p;
					if ((GetCursorPos(&p)) && (p.y >= 466) &&
												(xmilcfg.clockx)) {
						INIT_RENEWAL xmilcfg.clockfnt++;
						dclock_reset();
					}
				}
				return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;
#if 0
		case WM_IME_NOTIFY:
			if (wParam != IMN_OPENSTATUSWINDOW) {
				return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;
#endif
        case WM_DROPFILES:
			{
				HDROP		hDrop;
				char		DropFileName[MAX_PATH];
				int			uFileNo;
				int			i;

				DSound_Stop();
				hDrop = (HDROP)wParam;
        	    uFileNo = DragQueryFile((HDROP)wParam, 0xFFFFFFFF, NULL, 0);
				for (i=0; i<uFileNo; i++) {
					DragQueryFile(hDrop, i, DropFileName, MAX_PATH);
					if (is_d8ufile(DropFileName)) {
						fdd_ini(DropFileName);
						makecaption(1, NULL);
						break;
					}
				}
        	    DragFinish(hDrop);
				DSound_Play();
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return(0L);
}




int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
										LPSTR lpszCmdLine, int nCmdShow) {
	WNDCLASS	xmil;
	MSG			msg;
	WORD		framecnt = 0;
	HMENU		hMenu;

	if ((hInst = FindWindow(szClassName, NULL)) != NULL) {
		ShowWindow(hInst, SW_RESTORE);
		SetForegroundWindow(hInst);
		return(FALSE);
	}

	hInst = hInstance;

	file_setcd(__argv[0]);
	initload();
	winkeyinit106();

	if (!hPreInst) {
		xmil.style = CS_BYTEALIGNCLIENT | CS_HREDRAW | CS_VREDRAW;
		xmil.lpfnWndProc = WndProc;
		xmil.cbClsExtra = 0;
		xmil.cbWndExtra = 0;
		xmil.hInstance = hInstance;
		xmil.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
		xmil.hCursor = LoadCursor(NULL, IDC_ARROW);
		xmil.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
		xmil.lpszMenuName = MAKEINTRESOURCE(IDM_MAIN);
		xmil.lpszClassName = szClassName;
		if (!RegisterClass(&xmil)) {
			return(FALSE);
		}
	}

	hWndMain = CreateWindowEx(0,
						szClassName, szProgName,
						WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
						WS_MINIMIZEBOX,
						CW_USEDEFAULT, CW_USEDEFAULT,
#if T_TUNE
						SCREEN_WIDTH, SCREEN_HEIGHT+INFO_HEIGHT,
#else
						SCREEN_WIDTH, SCREEN_HEIGHT,
#endif
						NULL, NULL, hInstance, NULL);

#if T_TUNE
	ddraws_initwindowsize(SCREEN_WIDTH, SCREEN_HEIGHT+INFO_HEIGHT);
#else
	ddraws_initwindowsize(SCREEN_WIDTH, SCREEN_HEIGHT);
#endif

	makecaption(7, NULL);

	xmenu_setiplrom(xmilcfg.ROM_TYPE);
	xmenu_setsound(xmilcfg.SOUND_SW);
	xmenu_setskipline(xmilcfg.SKIP_LINE);
	xmenu_setresolute(xmilcfg.DIP_SW);
	xmenu_setbootmedia(xmilcfg.DIP_SW);
	xmenu_setkey(0);
	xmenu_setbtnrapid(xmilcfg.BTN_RAPID);
	xmenu_setbtnmode(xmilcfg.BTN_MODE);
	xmenu_setcpuspeed(xmilcfg.CPU8MHz);
	xmenu_setwaitflg(xmilcfg.NOWAIT);
	xmenu_setflame(xmilcfg.DRAW_SKIP);
	xmenu_setmotorflg(xmilcfg.MOTOR);
	xmenu_setz80save(xmilcfg.Z80SAVE);
	xmenu_setjoystick(xmilcfg.JOYSTICK);
	xmenu_setdispclk(xmilcfg.DISPCLK);
	xmenu_setdispmode(xmilcfg.DISPSYNC);
	xmenu_setmouse(xmilcfg.MOUSE_SW);

	ddraws_setscreenmode(SCMD_SETWINDOWED);
	ddraws_windowstats();
	ShowWindow(hWndMain, nCmdShow);
	UpdateWindow(hWndMain);

	hMenu = GetSystemMenu(hWndMain, FALSE);
	InsertMenu(hMenu, 0, MF_BYPOSITION | MF_STRING, IDM_SCREENCENTER,
							"&Centering");
	InsertMenu(hMenu, 1, MF_BYPOSITION | MF_STRING, IDM_SNAPENABLE,
							"&Window Snap");
	InsertMenu(hMenu, 2, MF_BYPOSITION | MF_STRING, IDM_BACKGROUND,
							"&Background");
	InsertMenu(hMenu, 3, MF_BYPOSITION | MF_STRING, IDM_BGSOUND,
							"Background &Sound");
	InsertMenu(hMenu, 4, MF_BYPOSITION | MF_SEPARATOR, 0, NULL);
#ifdef TRACE
	InsertMenu(hMenu, 4, MF_BYPOSITION | MF_STRING, IDM_TRACEONOFF,
							"&Trace");
#endif
	DrawMenuBar(hWndMain);

	xmenu_setwinsnap(xmilcfg.WINSNAP);
	xmenu_setbackground(xmilcfg.background);
	xmenu_setbgsound(xmilcfg.background);

	ddraws_init();
	if (ddraws_InitDirectDraw()) {
		ddraws_TermDirectDraw();
		disable_windowmenu();
		ddraws_setscreenmode(SCMD_SETFULLSCREEN);
		ddraws_windowstats();
		if (ddraws_InitDirectDraw()) {
			ddraws_TermDirectDraw();
			MessageBox(hWndMain, "Couldn't create DirectDraw Object",
													szProgName, MB_OK);
			return(FALSE);
		}
	}
	INIT_RESET
	mx_initdinput();

	if (!InitDirectSound()) {
		WAVE_INIT();
		WAVE_CREATE("fddseek.wav", 0, xmilcfg.MOTORVOL);
		WAVE_CREATE("fddseek1.wav", 1, xmilcfg.MOTORVOL);
#if T_TUNE
		WAVE_CREATE("cmtstop.wav", WAV_STOP, xmilcfg.MOTORVOL);
		WAVE_CREATE("cmtplay.wav", WAV_PLAY, xmilcfg.MOTORVOL);
		WAVE_CREATE("cmteject.wav",WAV_EJECT, xmilcfg.MOTORVOL);
		WAVE_CREATE("cmtff.wav",WAV_FFREW, xmilcfg.MOTORVOL);
#endif
	}

	x1r_init();

	if (__argc > 1) {
		for (int i=1; i<__argc; i++) {
			if (is_d8ufile(__argv[i])) {
				fdd_ini(__argv[i]);
				makecaption(1, NULL);
				break;
			}
		}
	}

	ddraws_redraw();

	xmilopening = 0;

	while(1) {
		if (!(xmilcfg.background & xmilforeground)) {
			if (PeekMessage(&msg, 0, 0, 0, PM_NOREMOVE)) {
				if (!GetMessage(&msg, NULL, 0, 0)) {
					break;
				}
				if ((msg.message != WM_SYSKEYDOWN) &&
					(msg.message != WM_SYSKEYUP)) {
					TranslateMessage(&msg);
				}
				DispatchMessage(&msg);
			}
			else {
				if (xmilcfg.DISPCLK) {
					WORKCLOCK_T *work = workclock_get();
					if (work) {
						makecaption(xmilcfg.DISPCLK << 1, work);
					}
				}
				if ((timer_getcount()) || (xmilcfg.NOWAIT)) {
					timer_setcount(0);
					joy_flash();
					mouse_callback();
					x1r_exec();
					INX1F_INC;
				}
				STREAM_CALLBACK();
			}
		}
		else {
			if (!GetMessage(&msg, NULL, 0, 0)) {
				break;
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	mouse_running(MOUSE_OFF);

	INX1F_alltrash();
	x1r_term();

	WAVE_TERM();
	TermDirectSound();

	mx_termdinput();
	ddraws_TermDirectDraw();

	initsave();

	return(msg.wParam);
}

